#include <stdio.h>
int n=1500,m;
float x[2048],y[2048],z[4],w[4];
main(int ac,char **av)
{
  int i,err;
  double x1;
  if(ac<2){ printf("\n\t **** minium 2 method *****\n");
            printf("\n\t Usage: mini2 1,2,3,4\n\n"); exit(0); }
  sscanf(av[1],"%d",&m);
  w[0]=1.23;  w[1]=2.34;  w[2]=3.45;  w[3]=4.56; 
  for(i=0;i<n;i++){
    x[i]=1.0*i;
    y[i]=w[0];
    x1=x[i];                                    // x1 must be double,
    if(m>1)y[i]+=w[1]*x1;                       // else carry cal_err
    if(m>2)y[i]+=w[2]*x1*x1;
    if(m>3)y[i]+=w[3]*x1*x1*x1;
  }
  printf("start: "); for(i=0;i<m;i++)printf("%5.3f ",w[i]); printf("\n");
  mini2(x,y,n, z,m);
  printf("mini calcu: "); for(i=0;i<m;i++)printf("%5.3f ",z[i]); printf("\n");
  my_parb(y,n,z,m,&err);
  printf("my_p calcu: "); for(i=0;i<m;i++)printf("%5.3f ",z[i]); printf("\n");
}

//  sig(x^4)*a + sig(x^3)*b + sig(x^2)*c = sig(x^2*y)
//  sig(x^3)*a + sig(x^2)*b + sig(x)*c   = sig(x*y)
//  sig(x^2)*a + sig(x)*b   + n*c        = sig(y)    
mini2(xx,yy,n, zz,mini)
float *xx,*yy,*zz; int n,mini;
{
  int i,j;
  double sy,sxy,sx2y,sx3y,  sx,sx2,sx3,sx4,sx5,sx6,  x,x2,x3,x4,x5,x6,y;
  double a[4][4],b[4];
  sy=sxy=sx2y=sx3y= sx=sx2=sx3=sx4=sx5=sx6=0.; 
  for(i=0;i<n;i++){
    x=xx[i]; y=yy[i];
    x2=x*x;  x3=x2*x;   x4=x2*x2;   x5=x2*x3;  x6=x3*x3;
    sy+=y;   sxy+=x*y;  sx2y+=x2*y; sx3y+=x3*y; 
    sx+=x;   sx2+=x2;   sx3+=x3;    sx4+=x4;   sx5+=x5;  sx6+=x6;
  }
  a[0][0]=n;   a[0][1]=sx;  a[0][2]=sx2; a[0][3]=sx3;
  a[1][0]=sx;  a[1][1]=sx2; a[1][2]=sx3; a[1][3]=sx4;
  a[2][0]=sx2; a[2][1]=sx3; a[2][2]=sx4; a[2][3]=sx5;
  a[3][0]=sx3; a[3][1]=sx4; a[3][2]=sx5; a[3][3]=sx6;
  b[0]=sy;     b[1]=sxy;    b[2]=sx2y;   b[3]=sx3y;
//for(j=0;j<mini;j++){
//  for(i=0;i<mini;i++)printf("%15.5le",a[j][i]); printf("\n");}
//for(i=0;i<mini;i++)printf("%15.5le",b[i]); printf("\n\n");
  matrix(a,b,mini);
  for(i=0;i<mini;i++)z[i]=b[i];
}
     
matrix(a,b,m)
double a[][4],*b; int m;
{
  int i,j,k,l; double s,t;
  for(i=0;i<m-1;i++){ s=0.;
    for(k=i;k<m;k++){ t=a[k][i]; if(t<0.)t=-t; if(t>s){ s=t; l=k; } }
    if(s==0.){ for(k=0;i<m;k++)b[k]=0; printf("Matrix err\n"); return; }
    if(i!=l){
      for(j=0;j<m;j++){ t=a[i][j]; a[i][j]=a[l][j]; a[l][j]=t;}
      t=b[i]; b[i]=b[l]; b[l]=t;
    } s=a[i][i];
    for(j=i+1;j<m;j++){
      t=a[j][i]/s; b[j]-=t*b[i];
      for(k=i;k<m;k++)a[j][k]-=t*a[i][k];
    }
  }
//for(j=0;j<m;j++){ for(i=0;i<m;i++)printf("%15.4le",a[j][i]); printf("\n"); }
  for(i=0;i<m;i++){ l=m-1-i;
    if(a[l][l]==0.){ b[l]=0.; continue; }
    t=b[l]; if(l!=m-1)for(j=1;j<=i;j++){ k=m-j; t-=a[l][k]*b[k]; }
    b[l]=t/a[l][l];
  }
}

my_parb(a,nn,bb,mm,err)
float *a,*bb; int nn,mm,*err;
{
  int i,j,k,l; double y,x,x2,x3,x4, mx[5][5],b[5], s[9];
  *err=0;
  for(i=0;i<mm;i++)b[i]=s[i]=s[i+mm]=0.; 
  for(i=0;i<nn;i++){ if(a[i]==0.)continue;       // if a[]==0, weight=0.
    y=a[i]; x=i; x2=x*x; x3=x*x2; x4=x2*x2;
    s[0]++; s[1]+=x; s[2]+=x2; s[3]+=x3; s[4]+=x2*x2;
    b[0]+=y;  b[1]+=y*x; b[2]+=y*x2; b[3]+=y*x3;
    if(mm<4)continue;  s[5]+=x2*x3; s[6]+=x3*x3; b[4]+=y*x4;         //m=4
    if(mm<5)continue;  s[7]+=x3*x4; s[8]+=x4*x4; b[5]+=y*x2*x3;      //m=5
  } for(j=0;j<mm;j++)for(i=0;i<mm;i++)mx[j][i]=s[j+i];
//for(j=0;j<mm;j++){for(i=0;i<mm;i++)printf("%15.5le",mx[j][i]); printf("\n");}
//for(i=0;i<mm;i++)printf("%15.5le",b[i]); printf("\n\n");
  if(s[0]<mm){// printf(" less data!\n");
               *err=1; return; }
// invert matrix
  for(i=0;i<mm-1;i++){ x=0.;
    for(k=i;k<mm;k++){ y=mx[k][i]; if(y<0.)y=-y; if(y>x){ x=y; l=k; } }
    if(x==0.){ *err=2;  return; }              //  printf("Zero_MATRIX\n");
    if(i!=l){
      for(j=0;j<mm;j++){ y=mx[i][j]; mx[i][j]=mx[l][j]; mx[l][j]=y;}
      y=b[i]; b[i]=b[l]; b[l]=y;
    } x=mx[i][i];
    for(j=i+1;j<mm;j++){
      y=mx[j][i]/x; b[j]-=y*b[i]; for(k=i;k<mm;k++)mx[j][k]-=y*mx[i][k];
    }
  }
//for(j=0;j<mm;j++){for(i=0;i<mm;i++)printf("%15.4le",mx[j][i]); printf("\n"); }
  for(i=0;i<mm;i++){ l=mm-1-i; if(mx[l][l]==0.){ b[l]=0.; continue; }
    y=b[l]; if(l!=mm-1)for(j=1;j<=i;j++){ k=mm-j; y-=mx[l][k]*b[k]; }
    b[l]=y/mx[l][l];
  }
  for(i=0;i<mm;i++)bb[i]=b[i];                  // out result
}
